use strict;
use warnings;
use utf8;
use feature qw(say);

use lib 'lib';

use App::GraphQL;
use App::GraphQL::Repository::Request;

my $requests = App::GraphQL::Repository::Request->get_all();
for my $request ($requests->@*) {
    use DDP { show_unicode => 1, use_prototypes => 0, colored => 1 };
    say 'generating cache (detail follows)...';
    p($request);
    my $result = App::GraphQL->execute_with_cache(
        $request->{query} // '',
        $request->{varaibles} // +{},
        $request->{operation_name} // '',
    ); 
    say 'result = ';
    p($result);
}
say 'done.';