package App::Error;

use strict;
use warnings;
use utf8;

use constant +{
    COMMENT_LENGTH_TOO_LONG => 'COMMENT_LENGTH_TOO_LONG',
    UNKNOWN_ERROR           => 'UNKNOWN_ERROR',
};

use constant ERROR_CODE_TO_MESSAGE => +{
    COMMENT_LENGTH_TOO_LONG() => 'Comment must not be longer than 10 characters.',
    UNKNOWN_ERROR()           => 'Unknown Internal Error',
};

sub new {
    my ($class, $code) = @_;

    return bless +{
        code => $code,
    }, $class;
}

sub code { shift->{code} }

sub message {
    my $code = shift->code;
    ERROR_CODE_TO_MESSAGE->{$code} // ERROR_CODE_TO_MESSAGE->{UNKNOWN_ERROR};
}

1;
