package App::GraphQL::Cache;

use strict;
use warnings;
use utf8;

use App::GraphQL::Util;
use JSON::XS qw(decode_json encode_json);
use Redis::Fast;

use constant KEY => 'cache';
use constant REDIS_SERVER => 'redis:6379';

sub fetch_cache {
    my ($class, $payload) = @_;
    my $redis = Redis::Fast->new(server => REDIS_SERVER);
    my $cache_key = KEY . ':' . App::GraphQL::Util->generate_hash_from_payload($payload);
    my $serialized_response = $redis->get($cache_key);
    return eval { decode_json($serialized_response) };
}

sub set_cache {
    my ($class, $payload, $response) = @_;
    my $redis = Redis::Fast->new(server => REDIS_SERVER);
    my $cache_key = KEY . ':' . App::GraphQL::Util->generate_hash_from_payload($payload);
    my $serialized_response = encode_json($response);
    $redis->set($cache_key, $serialized_response);
}

1;