package App::GraphQL::ErrorHandler;

use strict;
use warnings;
use utf8;

use GraphQL::Error;
use Scalar::Util qw(blessed);

sub handle {
    my ($class, $error) = @_;
    my $coerced_error = GraphQL::Error->coerce($error);

    if (blessed $error && ref($error) eq 'App::Error') {
        return $coerced_error->but(
            message    => $error->message,
            extensions => +{ code => $error->code },
        );
    } else {
        return $coerced_error->but(
            extensions => +{ code => 'UNKNOWN_ERROR'},
        );
    }
}

1;
