package App::GraphQL::Repository::Query;

use strict;
use warnings;
use utf8;

use App::Config;
use Encode qw(decode_utf8 encode_utf8);
use JSON::XS;
use JSON::XS qw(decode_json encode_json);
use Redis::Fast;

use constant KEY => 'query';

sub _key {
    my ($class, $hash) = @_;
    return KEY . ':' . $hash;
}

sub save {
    my ($class, $hash, $query) = @_;
    my $redis = Redis::Fast->new(server => App::Config::REDIS_SERVER);
    my $serialized_query = encode_utf8(encode_json($query));
    $redis->set($class->_key($hash), $serialized_query);
}

sub restore {
    my ($class, $hash) = @_;
    my $redis = Redis::Fast->new(server => App::Config::REDIS_SERVER);
    my $serialized_query = $redis->get($class->_key($hash));

    return eval { decode_json(decode_utf8($serialized_query)) };
}

1;
