package App::GraphQL::Repository::Request;

use strict;
use warnings;
use utf8;

use App::Config;
use Encode qw(encode_utf8 decode_utf8);
use JSON::XS qw(decode_json encode_json);
use Redis::Fast;

use constant KEY => 'request_log';

sub save {
    my ($class, $query, $variables, $operation_name) = @_;
    my $payload = +{ query => $query, varaibles => $variables, operation_name => $operation_name };
    my $serialized_payload = encode_utf8(encode_json($payload));
    my $redis = Redis::Fast->new(server => App::Config::REDIS_SERVER);
    $redis->zIncrBy(KEY, 1, $serialized_payload);
}

sub get_all {
    my $redis = Redis::Fast->new(server => App::Config::REDIS_SERVER);
    return [map {
        eval { decode_json(decode_utf8 $_) }
    } $redis->zRevRange(KEY, 0, -1)->@*];
}

1;
