package App::GraphQL::Resolver::Mutation;

use strict;
use warnings;
use utf8;

use App::Error;
use App::Repository::Review;

sub createReview {
    my ($class, $root_value, $args, $context, $info) = @_;
    my $comment = $args->{input}->{comment} // '';

    # 100文字より多い場合はエラー
    if (length $comment > 100) {
        die App::Error->new('COMMENT_LENGTH_TOO_LONG');
    }

    # 対象の Book に対してレビューを作成する
    my $review = App::Repository::Review->create_review(
        $args->{input}->{bookId},
        $comment,
    );

    return +{
        review => $review,
    };
}


1;
