package App::GraphQL::Type::Interface;

use strict;
use warnings;
use utf8;

use Class::Load qw(try_load_class);
use GraphQL::Type::Interface;

sub from_ast {
    my ($class, $name2type, $ast_node) = @_;

    # 対象のinterface名を取得して，個別の実装に型解決を移譲する
    my $name = $ast_node->{name};
    my $delegate = __PACKAGE__ . '::' . $name;
    my ($loaded, $error) = try_load_class($delegate);
    unless ($loaded && $delegate->can('resolve_type')) {
        die 'No Interface Implementation for ' . $name;
    }

    return GraphQL::Type::Interface->new(
        GraphQL::Type::Interface->_from_ast_named($ast_node),
        GraphQL::Type::Interface->_from_ast_fields($name2type, $ast_node, 'fields'),
        resolve_type => sub { $delegate->resolve_type(@_) },
    );
}

1;
