package App::Repository::Review;

use strict;
use warnings;
use utf8;

our $ID = 1;
our $STORE = +{};

sub create_review {
    my ($class, $book_id, $comment) = @_;

    # モック実装
    my $id = 'Review::' . $ID++;
    my $review = +{
        id      => $id,
        bookId => $book_id,
        comment => $comment,
    };
    $STORE->{$id} = $review;

    return $review;
}

sub get_by_id {
    my ($class, $id) = @_;

    return $STORE->{$id};
}

sub get_by_ids {
    my ($class, $ids) = @_;

    return +{map { $_ => $STORE->{$_} } $ids->@*};
}

1;
